package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRPostRel;
import cn.ibizlab.humanresource.core.humanresource.filter.HRPostRelSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRPostRel] 服务对象接口
 */
public interface IHRPostRelService extends IService<HRPostRel>{

    boolean create(HRPostRel et) ;
    void createBatch(List<HRPostRel> list) ;
    boolean update(HRPostRel et) ;
    void updateBatch(List<HRPostRel> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRPostRel get(String key) ;
    HRPostRel getDraft(HRPostRel et) ;
    boolean checkKey(HRPostRel et) ;
    boolean save(HRPostRel et) ;
    void saveBatch(List<HRPostRel> list) ;
    Page<HRPostRel> searchDefault(HRPostRelSearchContext context) ;
    List<HRPostRel> selectByHrpostid(String hrpostid) ;
    void removeByHrpostid(String hrpostid) ;
    List<HRPostRel> selectByPhrpostid(String hrpostid) ;
    void removeByPhrpostid(String hrpostid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRPostRel> getHrpostrelByIds(List<String> ids) ;
    List<HRPostRel> getHrpostrelByEntities(List<HRPostRel> entities) ;
}


